import numpy as np
import pickle
import os, pdb
# import pylab as plt
import matplotlib.pyplot as plt
import matplotlib.cm as cm
from sklearn.decomposition import PCA

with file(os.path.join(os.path.expanduser('~'), 'Datasets','StanfordTissue', 'processed_data','codedSamples.pickle')) as f:
    X = pickle.load(open(f))

plt.ion()

plt.matshow(X,cmap='hot') # Use -X to make this look good on paper. It's equivalent to inverting the colormap, but the actual values will be negative, which is bad if I show the colormap on the picture
plt.show()
plt.title('Sample vectors')
plt.xlabel('features')
plt.ylabel('samples')
plt.savefig(os.path.join(os.path.expanduser('~'), 'Datasets/StanfordTissue', 'processed_data/codedSamples.pdf'), format='pdf')

plt.matshow(np.cov(X),cmap='hot') # Again, make it negative to look good on paper
plt.show()
plt.title('Covariance matrix')
plt.savefig(os.path.join(os.path.expanduser('~'), 'Datasets/StanfordTissue', 'processed_data/covMatrix.pdf'), format='pdf')


pca = PCA(n_components=2)

Xp = pca.fit_transform(X)


plt.figure()
plt.plot(Xp[:,0], Xp[:,1], 'o', alpha=.5)  # plot transparent circles
plt.xlabel('1st principal component')
plt.ylabel('2nd principal component')
plt.title('Projection of patient data')
plt.savefig(os.path.join(os.path.expanduser('~'), 'Datasets','StanfordTissue', 'processed_data','pcaProjection.pdf'), format='pdf')

# I need to make this analysis with survival data
