# Encode samples using K-means hard assignment.

import numpy as np
import pickle
import os, pdb
import Image
from sklearn import metrics
from sklearn.cluster import KMeans
import pylab as plt
# import auxFunctions

# import teoPlot # my plotting functions

POS_METHOD = 'SIFT' # String that tells what is the method to locate keypoints ('SIFT', 'dense', 'Oxford')

kmeansModel = pickle.load(open(os.path.join(os.path.expanduser('~'), 'Datasets/StanfordTissue/processed_data/kmeansModel.pickle'), 'rb'))
# auxFunctions.showMeans(kmeansModel)

#-----------------------------------
featsDir = os.path.join(os.path.expanduser('~'),'Datasets/StanfordTissue', 'processed_data', 'NKI')
allFiles = os.listdir(featsDir)
nSamples = len(allFiles)
dim = kmeansModel.n_clusters
H = np.zeros((nSamples,dim))

for i in range(0, nSamples):
    fileName = allFiles[i]
    print fileName
    feats = np.load(os.path.join(featsDir, fileName)) # load features
    P = kmeansModel.predict(feats) # assign them to clusters
    # Map predictions to a histogram
    for p in P:
        H[i][p] += 1
    H[i] /= feats.shape[0] # normalise w.r.t. sum (i.e. number of samples in the case of hard voting)

pickle.dump(H, open(os.path.join(os.path.expanduser('~'), 'Datasets/StanfordTissue', 'processed_data/codedSamples.pickle'),'wb'))

# Visualising H
plt.matshow(H)
plt.show()

