import Image
import numpy as np
import os, pdb
import cPickle
import Image
from sklearn.cluster import KMeans
from sklearn.decomposition import PCA

# Importing James Hensman's stuff:
import sys
sys.path.append(os.path.join(os.path.expanduser('~'),'Code', 'colvb'))
from colvb import MMOG


#-----------------------------------
def LearnDictionary(featsDir, dicDir, dicMethod = 'Kmeans', K=100, samplesPerPerson = 0, dim=1024): 
    # maxFeats is a rough limit on the number of features loaded to
    #    build the dictionary. This is here to enable me to run with
    #    little memory.  
    # posMethod is a string that tells what is the method to locate
    #    keypoints ('SIFT', 'dense', 'Oxford')
    # K is the number of words in the dictionary
    # dim is the dimensionality of original feature vectors (32x32)

    #-----------------------------------
    if not os.path.exists(os.path.join(dicDir,'Img')):
        os.makedirs(os.path.join(dicDir,'Img'))
    
    dicFile = os.path.join(dicDir,'dicModel.pickle')
    if not os.path.exists(dicFile): # Build dictionary model if it's not there:
        if dicMethod == 'Kmeans':
            Xlist, fileList = auxFunctions.LoadDataset(featsDir, -1,dim) # load all samples
            X = Xlist[0]
            for doc in range(1,len(Xlist)):
                X = np.append(X,Xlist[doc], axis=0)

            print 'Clustering with Kmeans...'
            # i = 0
            # Image.fromarray(np.reshape(Xall[i],(32,32)).astype('uint8')).show();i+=1
            kmeansModel = KMeans(n_clusters=K, precompute_distances=0, n_jobs=1).fit(X)
            # see http://scikit-learn.org/dev/modules/generated/sklearn.cluster.KMeans.html
            # Alternative: use GMM:
            # http://scikit-learn.org/dev/modules/mixture.html
            # or LDA, or even better, James's MMOG below.
            cPickle.dump(kmeansModel, open(dicFile, "wb" ))
            auxFunctions.showKMeans(dicDir)
        
        else: # dicMethod == 'MMOG':
            X, fileList = auxFunctions.LoadDataset(featsDir, samplesPerPerson,dim)
            # fileList is not used
            
            # MMOG won't cope with high dimensional datasets, so I'm assuming
            # that instead of using raw feature vectors, their PCA projection is given.
            print 'Building MMOG...'
            m = MMOG(X=X, alpha=200)
            m.optimize()
            m.systematic_splits()
            m.pickle(mmogFile)

            # mmogModel.plot()
            # pb.show()
            auxFunctions.showMMOG(dicDir, featsDir)
        
        
