# execfile('setParams.py')
LVdim = 6 # Andreas used 14 in his MRD paper for the faces demo
gplvmFile = os.path.join(dicDir, GPmethod + '_' + str(LVdim) + 'D.pickle') 

# dicMethod = 'KmeansOnePatient'

if not os.path.exists(featsDir):
    extractFeatures.process_images(ImageDir, featsDir, detectionMethod)

if dicMethod == 'MMOG': # need PCA
    dicDir = os.path.join(DataDir,'Dictionary', dicMethod, '%03d'%dim)
    if dim < 1024:
        pcaFuncs.PCAprojAll(featsDir, pcaDir, dim)
        dic.LearnDictionary(projDir, dicDir, dicMethod, K, 0, dim)
    else:
        dic.LearnDictionary(featsDir, dicDir, dicMethod, K, 0, dim)
else:
    K = 9
    dicDir = os.path.join(DataDir,'Dictionary', dicMethod, 'k%03d'%K)
    dic.LearnDictionary(featsDir, dicDir, dicMethod, K, -1, dim)


if dicMethod.find('Kmeans') < 0: 
    stop

if not os.path.exists(gplvmFile):
    if not os.path.exists(bigXfile):
        dicFile = os.path.join(dicDir,'dicModel.pickle')
        with file(dicFile) as f:
            kmeansModel = cPickle.load(f)

        K = kmeansModel.n_clusters
        # kmeansModel.labels_ # this has the predictions (hard assignments) for the samples used at training.

        X, fileList = auxFunctions.LoadDataset(featsDir, samplesPerPerson = -1) 
        # I want to examine all the patches in the image
        bigX = np.zeros((len(fileList), dim*K)) # vector of all selected features
        for f in range(len(X)):
            # We want, for each cluster, find out which feature vector was
            # the nearest (i.e., the other way round as what
            # kmeansModel.predict() does).
            dists = kmeansModel.transform(X[f])
            idx = dists.argmin(axis=0)
            bigX[f,:] = np.hstack(X[f][idx,:])

        bigX.dump(bigXfile)
        bigXmean = bigX.mean()
        bigXstd = bigX.std()
        bigXmean.dump(bigXmeanFile)
        bigXstd.dump(bigXstdFile)

    else:
        with file(bigXfile) as f:
            bigX = cPickle.load(f)
        with file(bigXmeanFile) as f:
            bigXmean = cPickle.load(f)
        with file(bigXstdFile) as f:
            bigXstd = cPickle.load(f)

    if False:
        # Checking images off the vector, their mean and STD:
        with file(os.path.join(os.path.expanduser('~'), 'Precomputed','StanfordTissue','NKI','palette.txt')) as f:
            myPalette = cPickle.load(f)
        y = bigX.mean(0)
        data_show = GPy.util.visualize.image_show(y[None,:], dimensions=(32, 32), palette=myPalette)
        pb.title('Mean of all samples')
        y = bigX.std(0)
        data_show = GPy.util.visualize.image_show(y[None,:], dimensions=(32, 32), palette=myPalette)
        pb.title('STD of all samples')

    # Normalising the dataset in a way that preserves the differesnces between samples
    Y = bigX - bigXmean
    Y /= bigXstd

    if GPmethod == 'GPLVM':
        # k = GPy.kern.rbf(LVdim) + GPy.kern.bias(LVdim) + GPy.kern.white(LVdim,0.0001)
        m = GPy.models.GPLVM(Y = Y, Q=LVdim)
        # m = GPy.models.GPLVM(Y = Y[:,0:dim], Q=LVdim)
        # m.checkgrad(verbose=1,step=1e-3)

        m.constrain_bounded('noise', 1e-6, 10)
        # m['variance'] = 1.
        # m['noise'] = 0.01
        # m['len'] = 2.
        # m.constrained_indices[0] = m.constrained_indices[0][:-1]
        m.ensure_default_constraints()
        m.optimize('scg',messages=1, max_f_eval=10000)

    # Bayesian GPLVM:
    if GPmethod == 'BayesianGPLVM':
        k = GPy.kern.rbf(LVdim,ARD=True) + GPy.kern.bias(LVdim)# + GPy.kern.white(LVdim,0.0001)
        m = GPy.models.Bayesian_GPLVM(Y, Q=LVdim, M=100, kernel = k)
        # m = GPy.models.Bayesian_GPLVM(Y = Y[:,0:dim], Q=LVdim, M=25, kernel = k)
        # m.checkgrad('white')
        # m.constrain_fixed('noise',0.08)
        # m.constrain_positive('X_va')
        # m.constrain_positive('X_[^v]')

        # print m
        m.constrain_bounded('noise', 1e-6, 10)
        m.ensure_default_constraints()
        m.optimize('scg',messages=1)

        # m.likelihood.YYT.shape
        # m.plot_latent(which_indices=(0,1))
        # m.Z
        # pb.figure()
        # pb.plot(m.Z[:,0],m.Z[:,1],'ro')
        # print m

    m.pickle(gplvmFile)

else:
    print 'Loading ' + gplvmFile
    with file(gplvmFile) as f:
        m = cPickle.load(f)

# Visualising it:
# ax = m.plot_latent(which_indices=(0,1),resolution=10)
y = m.likelihood.Y[0,:]
with file(bigXmeanFile) as f:
    bigXmean = cPickle.load(f)
with file(bigXstdFile) as f:
    bigXstd = cPickle.load(f)
with file(os.path.join(os.path.expanduser('~'), 'Precomputed','StanfordTissue','NKI','palette.txt')) as f:
    myPalette = cPickle.load(f)

fig, (latent_axes, sense_axes) = pb.subplots(1, 2)
pb.sca(latent_axes)
m.plot_latent()

data_show = GPy.util.visualize.image_show(y[None,:], dimensions=(32, 32), transpose=False, invert=False, scale=False, palette=myPalette, presetMean = bigXmean, presetSTD = bigXstd) # use bigX.mean() and bigX.std() here
lvm_visualizer = GPy.util.visualize.lvm_dimselect(m.X[0, :], m, data_show, latent_axes=latent_axes, sense_axes=sense_axes)
raw_input('Press enter to finish')
pb.close('all')

