from sklearn.decomposition import PCA
import cPickle
import os
import numpy as np
import auxFunctions

#-------------------------------------
def buildPCAmodel(featsDir, pcaDir): # I'm not using PCA.fit_transform for a good reason.
    Xlist, fileList = auxFunctions.LoadDataset(featsDir, -1) # load all features

    Xall = Xlist[0]
    for i in range(1,len(Xlist)):
        Xall = np.append(Xall, Xlist[i], axis=0)

    srcDim = X.shape[2]

    modelFile = os.path.join(pcaDir,'pcaModel.pickle')

    print 'Fitting PCA'
    pca = PCA() # I'm fitting PCA with all components, to enable setting the number of components wanted afterwards
    # I'm not whitening the vectors within PCA as it seems to destroy a lot of information.
    # Analysing the percentage of variance explained the retained components:
    pca.fit(Xall)
    # a = pca.explained_variance_ratio_
    # a[0:80].sum() # This shows that the first 45 components explain 80.22% of the variance, so I'll keep 80 PCs
    # print 'Computing PCA'
    # nPCs = 10
    # pca = PCA(nPCs)
    # Xp = pca.fit_transform(Xall)

    if not os.path.exists(pcaDir):
        os.makedirs(pcaDir)
        cPickle.dump(pca, open(modelFile, "wb" ))

#-------------------------------------
def PCAprojAll(featsDir, pcaDir, dim=2): # Project all samples using PCA
    modelFile = os.path.join(pcaDir,'pcaModel.pickle')
    if not os.path.exists(modelFile):
        buildPCAmodel(featsDir, pcaDir)

    projDir = os.path.join(pcaDir,'Proj_%03d'%dim)
    print 'Projecting samples with PCA to ' + projDir
    if not os.path.exists(projDir):
        os.makedirs(projDir)
    if os.listdir(projDir) == []: # Build the files only if they are not already there.
        pca = cPickle.load(open(modelFile,"rb"))
        for fileName in os.listdir(featsDir):
            if '.pickle' in fileName:
                print fileName
                X = np.load(os.path.join(featsDir, fileName))
                Xp = pca.transform(X)[:,0:dim]
                Xp.dump(os.path.join(projDir, fileName))
        print 'Finished projecting samples with PCA!'
    else:
        print 'PCA projection not computed, the directory was not empty.'

