import numpy as np
import pandas
from sklearn.cluster import KMeans

data = pandas.read_csv('/home/teo/Datasets/StanfordTissue/NKI_SurvivalData_mmc1.csv')

n_samples = data.shape[0]
dim = data.shape[1]

X = np.zeros((n_samples, dim-1)) # leaving 'rosid' out
# Design matrix convension:
#   each sample is in a row, columns are features.

X = data.values[:,1:]

for f in range(dim-1):
    if not np.isreal(X[0,f]):
        symbols = np.unique(X[:,f])
        for c in range(len(symbols)):
            idx = (X[:,f] == symbols[c])
            X[idx,f] = np.real(c)

X = np.array(X, dtype=np.float64)
Xnorm = (X - X.mean(axis=0))/X.std(axis=0, ddof=1)

# Done! Now, cluster X? Ask Alan about this type of data, and wether GPy can deal with descrete spaces.

K = 5 # use leave-one-patient-out in the cell detection experiments
kmeansModel = KMeans(n_clusters=K).fit(X)

# Now, find the K-medians (samples that are nearest to the means)
dists = kmeansModel.transform(X)
medians = dists.argmin(axis=0)

print data['rosid'][medians] # Interesting patient IDs:
# index  ID    has_image
# 119    207    yes
# 147    241    yes
# 97     183    yes
# 205    307    yes
# 34     109    yes
# 59     140    no
# 59     140    no

# NEXT: build dataset of clicks :-)
