# Set parameters for the AMIDA2013 experiments
# This file keeps a record of main experiment parameters


experimentID = 1

if experimentID == 0: # Bayesian GPLVM on sparse coded data    
    which_view = 'SparseCoding' # Which view of the data: 'SparseCoding', 'RawImages', 'Pyramid', 'Violet'
    GPmethod = 'GP' # 'BayesianGPLVM' 'GPLVM' 'MRD' 'Ricardo' 'GP' 'NearestNeighbour' 'SparseGP'
    LVdim = 0

elif experimentID == 1: # Simple GP regression with Violet's features
    which_view = 'Violet' # Which view of the data: 'SparseCoding', 'RawImages', 'Pyramid', 'Violet'
    GPmethod = 'GP' # 'BayesianGPLVM' 'GPLVM' 'MRD' 'Ricardo' 'GP' 'NearestNeighbour' 'SparseGP'
    LVdim = 0

elif experimentID == 2: 
    which_view = 'SparseCoding' # Which view of the data: 'SparseCoding', 'RawImages', 'Pyramid', 'Violet'
    GPmethod = 'GPLVM' # 'BayesianGPLVM' 'GPLVM' 'MRD' 'Ricardo' 'GP' 'NearestNeighbour' 'SparseGP'
    LVdim = 8

elif experimentID == 3: 
    which_view = 'SparseCoding' # Which view of the data: 'SparseCoding', 'RawImages', 'Pyramid', 'Violet'
    GPmethod = 'BayesianGPLVM' # 'BayesianGPLVM' 'GPLVM' 'MRD' 'Ricardo' 'GP' 'NearestNeighbour' 'SparseGP'
    LVdim = 8
    num_inducing = 100

elif experimentID == 4: 
    which_view = 'SparseCoding' # Which view of the data: 'SparseCoding', 'RawImages', 'Pyramid', 'Violet'
    GPmethod = 'BayesianGPLVM2' # 'BayesianGPLVM' 'GPLVM' 'MRD' 'Ricardo' 'GP' 'NearestNeighbour' 'SparseGP'
    LVdim = 8
    num_inducing = 100

elif experimentID == 5: 
    which_view = 'Violet' # Which view of the data: 'SparseCoding', 'RawImages', 'Pyramid', 'Violet'
    GPmethod = 'Ricardo' # 'BayesianGPLVM' 'GPLVM' 'MRD' 'Ricardo' 'GP' 'NearestNeighbour' 'SparseGP'
    LVdim = 8
    num_inducing = 100


# ######
# Common parameters

if which_view == 'SparseCoding':
    n_clusters = 200 # for SparseGP
    im_rescale = 0.5 # parameter to resize images before extracting patches for dictionary learning
    n_components = 100 # number of basis in sparse coding
    patch_size = (5, 5) # sub-patch size used for dictionary learning

else:
    n_components = 0 # number of basis in sparse coding
    patch_size = (0, 0) # sub-patch size used for dictionary learning
