# import matplotlib 
# matplotlib.use('Qt4Agg') # There must be a way of setting this automatically at Python startup.
# import extractFeatures
import pcaFuncs
import learnDictionary as dic
import os, pdb
import cPickle
import pylab as pb
import numpy as np
import auxFunctions
import GPy

# Hack to ignore deprecation warnings while we don't update GPy for the new syntax of lapack/flapack
import warnings
warnings.simplefilter('ignore', DeprecationWarning)

pb.ion()

# import encodeSamples
# import analyseSamples
# import auxFunctions

detectionMethod = 'Oxford' # 'SIFT' # 'dense'
dicMethod = 'Kmeans' # 'KmeansOnePatient' # 'MMOG' # 'Kmeans'

dim = 1024 # Number of Principal Componentes (or original dimensionality of patches). 
# with SIFT-detected patches, 175 PCs explains 95.07% of the variance
# with Oxford-detected patches, 125 PCs explain 93.11% of the variance
# but 175 takes too much memory for our server (laplace)
ImageDir = os.path.join(os.path.expanduser('~'), 'Datasets','StanfordTissue', 'NKI_HE', 'NKI_Images')
DataDir = os.path.join(os.path.expanduser('~'), 'Precomputed','StanfordTissue', 'NKI', detectionMethod)
featsDir = os.path.join(DataDir,'Features')
pcaDir = os.path.join(DataDir,'PCA')
projDir = os.path.join(pcaDir,'Proj_%03d'%dim)

K = 9
dicDir = os.path.join(DataDir,'Dictionary', dicMethod, 'k%03d'%K)

# Rearranging features as Neil suggested and then do GPLVM on them.
GPmethod = 'BayesianGPLVM' # 'GPLVM' # 'BayesianGPLVM'
bigXfile = os.path.join(dicDir,'bigX.pickle') 
bigXmeanFile = os.path.join(dicDir,'bigXmean.pickle') 
bigXstdFile = os.path.join(dicDir,'bigXstd.pickle') 
