execfile('setParams.py')
LVdim = 14 # Andreas used 14 in his MRD paper for the faces demo
gplvmFile = os.path.join(dicDir, GPmethod + '_' + str(LVdim) + 'D.pickle') 

modelFile = GPmethod + '_' +  str(LVdim) + 'D_first_patient.pickle'
XmeanFile = 'Xmean.pickle'
XstdFile = 'Xstd.pickle'

if True: # not os.path.exists(modelFile):
    f = 0
    fileList = os.listdir(featsDir)
    fileName = fileList[0]
    X = np.load(os.path.join(featsDir, fileName))
    Xmean = X.mean()
    Xn = X - Xmean
    Xstd = Xn.std() 
    Xn /= Xstd
    Xmean.dump(XmeanFile)
    Xstd.dump(XstdFile)
    if GPmethod == 'BayesianGPLVM':
        k = GPy.kern.rbf(LVdim,ARD=True) + GPy.kern.bias(LVdim)# + GPy.kern.white(LVdim,0.0001)
        m = GPy.models.Bayesian_GPLVM(Xn, Q=LVdim, M=100, kernel = k)
    else:
        m = GPy.models.GPLVM(Xn, Q=LVdim)
    m.constrain_bounded('noise', 1e-6, 10)
    m.ensure_default_constraints()
    m.optimize('scg',messages=1, max_f_eval=10000)
    m.pickle(modelFile)

else:
    print 'loading ' + modelFile

    with file(modelFile) as f:
        m = cPickle.load(f)

    with file(XmeanFile) as f:
        Xmean = cPickle.load(f)

    with file(XstdFile) as f:
        Xstd = cPickle.load(f)


y = m.likelihood.Y[0,:]

fig, (latent_axes, sense_axes) = pb.subplots(1, 2)
pb.sca(latent_axes)
m.plot_latent(which_indices=(0,1))
myPalette = cPickle.load(open(os.path.join(os.path.expanduser('~'), 'Precomputed','StanfordTissue','NKI','palette.txt'), "rt" ) )
data_show = GPy.util.visualize.image_show(y[None,:], dimensions=(32, 32), transpose=False, invert=False, scale=False, palette=myPalette, presetMean = Xmean, presetSTD = Xstd) 
lvm_visualizer = GPy.util.visualize.lvm_dimselect(m.X[0, :], m, data_show, latent_axes=latent_axes, sense_axes=sense_axes)
raw_input('Press enter to finish')
pb.close('all')


